/* BSE - Bedevilled Sound Engine
 * Copyright (C) 1998 Olaf Hoehmann and Tim Janik
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef	__BSE_PRIVATE_H__
#define	__BSE_PRIVATE_H__

#include	<bse/bsebase.h>
#include	<bse/bsepattern.h>


#ifdef __cplusplus
extern "C" {
#pragma }
#endif /* __cplusplus */


/* instruments
 */
BseInstrument*  bse_instrument_type_sample_new  (BseSong                *song,
						 BseSample              *sample);
void		bse_instrument_handle_changed	(BseSong          	*song,
						 BseInstrument    	*instrument);
void		bse_instrument_delete		(BseInstrument		*instrument);

/* patterns
 */
BsePattern*     bse_pattern_new             (BseSong    *song);
void            bse_pattern_delete          (BsePattern *pattern);

     



#ifdef __cplusplus
#pragma {
}
#endif /* __cplusplus */

#endif /* __BSE_PRIVATE_H__ */
